services:
  nginx:
    image: registry.gitlab.com/naturalis/bii/xenocanto/xeno-canto/nginx:latest
    restart: always
    volumes:
      - ${DATA_PATH:-/data}/graphics:/var/www/graphics:rw,delegated
      - ${DATA_PATH:-/data}/ranges:/var/www/ranges:rw,delegated
      - ${DATA_PATH:-/data}/sounds:/var/www/sounds:rw,delegated
      - ${DATA_PATH:-/data}/sitemaps:/var/www/sitemaps:rw,delegated
      - ${DATA_PATH:-/data}/docs:/var/www/docs:rw,delegated
    depends_on:
      - php-fpm
    networks:
      - web

  php-fpm:
    image: registry.gitlab.com/naturalis/bii/xenocanto/xeno-canto/php-fpm:latest
    restart: always
    env_file:
      - .env
    networks:
      - web
      - backend
    volumes:
      - ${DATA_PATH:-/data}/avesecho:/var/www/avesecho:rw,delegated
      - ${DATA_PATH:-/data}/graphics:/var/www/graphics:rw,delegated
      - ${DATA_PATH:-/data}/ranges:/var/www/ranges:rw,delegated
      - ${DATA_PATH:-/data}/sounds:/var/www/sounds:rw,delegated
      - ${DATA_PATH:-/data}/sitemaps:/var/www/sitemaps:rw,delegated
      - ${DATA_PATH:-/data}/docs:/var/www/docs:rw,delegated
      - ${DATA_PATH:-/data}/minio:/data/minio:rw,delegated

  minio:
    image: minio/minio:RELEASE.2022-10-24T18-35-07Z
    restart: always
    environment:
      MINIO_ROOT_USER: ${MINIO_ROOT_USER:?Variable MINIO_ROOT_USER is empty}
      MINIO_ROOT_PASSWORD: ${MINIO_ROOT_PASSWORD:?Variable MINIO_ROOT_PASSWORD is empty}
    networks:
      - web
    command: server /data/minio --console-address ":9001"
    volumes:
      - ${DATA_PATH:-/data}/minio:/data/minio

  docker-socket-proxy:
    image: tecnativa/docker-socket-proxy:0
    restart: always
    networks:
      - docker-socket-proxy
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock:ro,delegated
    environment:
      CONTAINERS: 1

  redis:
    image: bitnami/redis:7.0
    restart: always
    ports:
      - "6379:6379"
    networks:
      - backend
    environment:
      REDIS_PASSWORD: ${REDIS_PASSWORD:?Variable REDIS_PASSWORD is empty}

  avesecho:
    image: registry.gitlab.com/arise-biodiversity/dsi/algorithms/avesecho-v1/avesechov1:${AVESECHO_TAG:-v1.1}
    restart: always
    entrypoint: ./run-endpoint.sh
    ports:
      - "5678:5678"
    networks:
      - backend
    shm_size: 4g

networks:
  web:
    internal: false
  backend:
    internal: true
  docker-socket-proxy:
    internal: true
